include     TestDll.inc
include     Console.inc

.data

DllName     db 'Console.dll',0
func        db 'StdOut',0
message     db 'DLL extracted from the executable',0

.data?

hFile       dd ?
bWritten    dd ?
hInst       dd ?

.code

start:

    invoke  CreateFile,ADDR DllName,GENERIC_WRITE,0,0,\
            CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,0
    mov     hFile,eax
    invoke  WriteFile,eax,ADDR pDLL,ln_pDLL,ADDR bWritten,0
    invoke  CloseHandle,hFile           ; Write the DLL to disc

    invoke  LoadLibrary,ADDR DllName    ; Load the DLL
    mov     hInst,eax
    invoke  GetProcAddress,eax,ADDR func 
    invoke  pr1 PTR eax,ADDR message    ; eax points the address
    invoke  FreeLibrary,hInst           ; of the StdOut function
    invoke  ExitProcess,0
    
END start

